<?php
/*

Copyright (c)2002-2003 DuckCorp(tm) and RtpNet(tm)



This file is part of LMS.

LMS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

LMS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LMS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

	function manage_preprocess()
	{
		global $entry, $entry2;

		get_from_multientry("mail", "mail");

		if ($object!="Admin User")
			get_from_checkbok("isdisactivated");

		if ($object="Common User")
			get_from_checkbok("contributionispaid");
	}

	function manage_check_validity()
	{
		global $error, $entry, $entry2, $object;

		manage_check_validity_1();
		if (!$error)
			if ($entry2[old_uid]!=$entry[uid][0])
				manage_check_validity_2();
		if (!$error)
			if ($entry2[old_uid_number]!=$entry["uidnumber"][0])
				manage_check_validity_3();
	}

	function manage_check_validity_1()
	{
		global $error, $entry, $entry2, $object, $config;

		test_attribute_required("User Name", "uid");
		if (!$error)
			test_attribute_without_space("User Name", "uid");
		
		test_attribute_required("UID Number", "uidnumber");
		if (!$error)
			test_attribute_is_int("UID Number", "uidnumber");

		test_attribute_required("Home Directory", "homedirectory");
		if (!$error)
			test_attribute_without_space("Home Directory", "homedirectory");
			
		if ($object=="Service User")
		{
			test_attribute_required("Description", "description");
		}
		else
		{
			test_attribute_required("Surname", "sn");
		
			test_attribute_required("Given Name", "givenname");

			if ($entry["roomnumber"][0]!="")
				test_attribute_is_int("Room Number", "roomnumber");

			if ($entry["homephone"][0]!="")
				test_attribute_is_int("Home Telephone", "homephone");

			if ($entry["mobile"][0]!="")
				test_attribute_is_int("Mobile Telephone", "mobile");
		}
		
		if ($object=="Admin User")
		{
			if ($entry[homephone][0]=="" && $entry[mobile][0]=="")
			{
				print("<TR><TD class=col3 colspan=2>An Administrator must give a phone number (mobile or home)</TD></TR>");
				$error=true;
			}
			if ($entry[mail][0]=="")
			{
				print("<TR><TD class=col3 colspan=2>An Administrator must give an email address</TD></TR>");
				$error=true;
			}
		}

		if ($entry2[clearphoto])
		{
			if (file_exists($config[photospath]."/".$entry[uid][0].".jpg"))
				unlink($config[photospath]."/".$entry[uid][0].".jpg");
		}

		if ($_FILES[photo][name])
		{
			$upload=false;

			if ($_FILES[photo][error] && $_FILES[photo][error]!=0)
				print("<TR><TD class=col3 colspan=2>An error happened while uploading file</TD></TR>");
			else if ($_FILES[photo][type]!="image/jpeg")
				print("<TR><TD class=col3 colspan=2>The selected file must be a JPEG image</TD></TR>");
			else
			{
				$imginfo=getimagesize($_FILES[photo][tmp_name]);
				if ($imginfo[2]!=2)
					print("<TR><TD class=col3 colspan=2>The selected file must be a JPEG image</TD></TR>");
				else if ($imginfo[0]!=160 && $imginfo[1]!=212)
					print("<TR><TD class=col3 colspan=2>The photo must be a 160x212 sized image</TD></TR>");
				else
				{
					exec("mv ".$_FILES[photo][tmp_name]." ".$config[photospath]."/".$entry[uid][0].".jpg");
					$upload=true;
				}
			}

			if (!$upload)
			{
				if (file_exists($_FILES[photo][tmp_name]))
					unlink($_FILES[photo][tmp_name]);
				$error=true;
			}
		}
}

	function manage_check_validity_2()
	{
		global $error, $entry, $userslist;

		if (in_array($entry["uid"][0], $userslist[0]))
		{
			print("<TR><TD class=col3 colspan=2>This Name is already Used by another User</TD></TR>");
			$error=true;
		}
	}

	function manage_check_validity_3()
	{
		global $error, $entry, $userslist;

		if (in_array($entry["uidnumber"][0], $userslist[1]))
		{
			print("<TR><TD class=col3 colspan=2>This UID Number is already Used by another Group</TD></TR>");
			$error=true;
		}
	}

	function manage_process()
	{
		global $entry, $object;

		test_password_is_crypted();

		if ($object=="Service User")
		{
			//$entry[cn][0]="Service User ".$entry[uid][0];
			$entry[cn][0]=$entry[uid][0];
		}
		else
		{
			$entry[cn][0]=$entry[sn][0]." ".$entry[givenname][0];

			$entry[initials][0]=strtoupper(substr($entry[sn][0], 0, 1).".".substr($entry[givenname][0], 0, 1).".");
		}
	}

	function manage_propagate_changes()
	{
		global $ds, $config, $entry, $entry2, $object;
		
		if ($entry2[old_uid]!=$entry[uid][0])
		{
			propagate_changes("memberUid", $entry2[old_uid], $entry[uid][0]);
			propagate_changes("ownerUID", $entry2[old_uid], $entry[uid][0]);
			propagate_changes("adminUID", $entry2[old_uid], $entry[uid][0]);
		}
	}

	$oldkey_manage="old_uid";
	$key_manage="uid";
?>
